/*
	PG Lottery Number Generator for XFBB by Stewart Wilkinson G0LGS 
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
#include <unistd.h>
#include <string.h> 
#include <time.h>

#include "utils.h"

time_t time_now;
struct tm *now;

#define HEAD "| ** LOTTERY NUMBER GENERATOR V" Version " (c) by G0LGS ** |"

#define MAXRND 49

int main(int argc, char **argv)
{
	int num;
	int cnt;
	int l1;
	int l2;
	int fnd;
	int RND[6];
	long loop;
	long lines = 1;
	char arg[80];
	char call[10];
	char *p;

	/* Get Current Time Information */
	time_now = time(NULL);
	now = localtime( &time_now );

	fprintf( stdout, "=====================================================\n" );
	fprintf( stdout, "%s\n", HEAD );
	fprintf( stdout, "=====================================================\n" );

	if( argc <= 5 ){
		fprintf( stderr, "\nNot enough Parameters\n\n" );
		return 0;
	}

	strcpy(	call, argv[1] );
	if( (p = strstr( call, "-" ) ) )
		 *p = '\0';

	/* Check Parameters */
	if( argc >= 6 ){

		/* 5th argument is user parameter */
		strcpy( arg, argv[5] );

		/* if not '' */
		if( *arg != '\0' ){

			/* Try converting to number */
			lines = strtol( arg, &p, 0 );

			if( errno ){
				fprintf( stderr, "\n'%s' is not a valid number\n\n", arg );
				return 0;
			}

			if( p == arg ){
				fprintf( stderr, "\n'%s' is not a valid number\n\n", arg );
				return 0;
			}
		}

	}

	if( (lines < 1) || (lines > 10) ) {
		fprintf( stdout, "\nNo of lines must be betweed 1 and 10\n\n" );
		return 0;
	}

	fprintf( stdout, "\tNumbers for %s at %02d:%02d:%02d on %02d/%02d/%02d\n\n", call, now->tm_hour, now->tm_min, now->tm_sec, now->tm_mday, now->tm_mon, now->tm_year % 100 );

	/* seed the random Number generator */
	srandom( time_now );


	for( loop=1; loop <= lines ; loop++ ){

		cnt = 1;
		while( cnt <= 6 ) {

			/* Random Number in Range 1 - MAXRND */
			num = (random() % MAXRND ) + 1;

			if( cnt == 1 ) {
				RND[cnt] = num;
				cnt++;

			}else{
				fnd = 0;
				for( l1 = 1; l1 < cnt ; l1++ ) {
					if( RND[l1] == num ){
						fnd = 1;
					}
				}

				if( ! fnd ) {
					RND[cnt] = num;
					cnt++;
				}
			}

		}


		/* Sort the Numbers */
		for( l2 = 1; l2 <= 5 ; l2++){
			for( l1 = 1; l1 <= 5 ; l1++){
				if( RND[l1+1] < RND[l1] ){
					num = RND[l1+1];
					RND[l1+1] = RND[l1];
					RND[l1] = num;
				}
			}
		}

		/* Print the Numbers */

		fprintf( stdout, "\t" );

		for( l1 = 1; l1 <= 6 ; l1++ ) {
			fprintf( stdout, "%2d  ", RND[l1] );
		}

		fprintf( stdout, "\n" );

	}

	fprintf( stdout, "\n" );
	exit(0);
}

